<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_RentacarLocation ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_RentacarLocation extends AbstractStructArrayBase
{
    /**
     * The RentacarLocation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_RentacarLocation[]
     */
    public $RentacarLocation;
    /**
     * Constructor method for ArrayOfJP_RentacarLocation
     * @uses ArrayOfJP_RentacarLocation::setRentacarLocation()
     * @param \StructType\JP_RentacarLocation[] $rentacarLocation
     */
    public function __construct(array $rentacarLocation = array())
    {
        $this
            ->setRentacarLocation($rentacarLocation);
    }
    /**
     * Get RentacarLocation value
     * @return \StructType\JP_RentacarLocation[]|null
     */
    public function getRentacarLocation()
    {
        return $this->RentacarLocation;
    }
    /**
     * This method is responsible for validating the values passed to the setRentacarLocation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRentacarLocation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRentacarLocationForArrayConstraintsFromSetRentacarLocation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_RentacarLocationRentacarLocationItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_RentacarLocationRentacarLocationItem instanceof \StructType\JP_RentacarLocation) {
                $invalidValues[] = is_object($arrayOfJP_RentacarLocationRentacarLocationItem) ? get_class($arrayOfJP_RentacarLocationRentacarLocationItem) : sprintf('%s(%s)', gettype($arrayOfJP_RentacarLocationRentacarLocationItem), var_export($arrayOfJP_RentacarLocationRentacarLocationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RentacarLocation property can only contain items of type \StructType\JP_RentacarLocation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RentacarLocation value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RentacarLocation[] $rentacarLocation
     * @return \ArrayType\ArrayOfJP_RentacarLocation
     */
    public function setRentacarLocation(array $rentacarLocation = array())
    {
        // validation for constraint: array
        if ('' !== ($rentacarLocationArrayErrorMessage = self::validateRentacarLocationForArrayConstraintsFromSetRentacarLocation($rentacarLocation))) {
            throw new \InvalidArgumentException($rentacarLocationArrayErrorMessage, __LINE__);
        }
        $this->RentacarLocation = $rentacarLocation;
        return $this;
    }
    /**
     * Add item to RentacarLocation value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RentacarLocation $item
     * @return \ArrayType\ArrayOfJP_RentacarLocation
     */
    public function addToRentacarLocation(\StructType\JP_RentacarLocation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_RentacarLocation) {
            throw new \InvalidArgumentException(sprintf('The RentacarLocation property can only contain items of type \StructType\JP_RentacarLocation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RentacarLocation[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_RentacarLocation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_RentacarLocation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_RentacarLocation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_RentacarLocation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_RentacarLocation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RentacarLocation
     */
    public function getAttributeName()
    {
        return 'RentacarLocation';
    }
}
